/**
 * 通用生成数据库 id 函数，{8位时间戳}-{6位随机码}
 */

const { padLeft } = require('./extender.cjs')
const { int2str, str2int } = require('./str2int.cjs')

let nanoid = null

module.exports = async function () {
    if (!nanoid) {
        const { customAlphabet } = await import('nanoid/async')
        nanoid = customAlphabet('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', 6)
    }
    const dt = new Date()
    const ticks = dt.getTime()
    const rdm = await nanoid()
    return `${padLeft(int2str(ticks),'0',8)}-${rdm}`
}