/**
 * 对 js 扩充常用函数
 */

// 左右字符串填充
function padCharTo(oldStr, side, char, len)  {
    // 参数检查
    // 填充字符
    let str = ''
    if (oldStr.length < len) for (let i = 1; i <= len - oldStr.length; i++) str += char
    if (side == 'left') return str + oldStr
    else return oldStr + str
}
function padLeft (str, char, len)  {
    return padCharTo(str, 'left', char, len)
}
function padRight (str, char, len)  {
    return padCharTo(str, 'right', char, len)
}

// 日期字符串
function dateString(dt)  {
    return dt.getFullYear() + '-' + padLeft((dt.getMonth() + 1).toString(), '0', 2) + '-' + padLeft(dt.getDate().toString(), '0', 2)
}
// 日期数字
function dateNumber(dt)  {
    return parseInt(dt.getFullYear() + padLeft((dt.getMonth() + 1).toString(), '0', 2) + padLeft(dt.getDate().toString(), '0', 2))
}
// 时间字符串
function timeString(dt)  {
    return padLeft(dt.getHours().toString(), '0', 2) + ':' + padLeft( dt.getMinutes().toString(), '0', 2) + ':' + padLeft(dt.getSeconds().toString(), '0', 2)
}
// 以秒为单位的时间数字
function timeNumber_seconds(dt)  {
    return dateNumber(dt) * 1000000 + parseInt(padLeft(dt.getHours().toString(), '0', 2) + padLeft( dt.getMinutes().toString(), '0', 2) + padLeft(dt.getSeconds().toString(), '0', 2))
}
// 以分为单位的时间数字
function timeNumber_minutes(dt)  {
    return dateNumber(dt) * 10000 + parseInt(padLeft(dt.getHours().toString(), '0', 2) + padLeft( dt.getMinutes().toString(), '0', 2))
}
// 以小时为单位的时间数字
function timeNumber_hours(dt)  {
    return dateNumber(dt) * 100 + parseInt(padLeft(dt.getHours().toString(), '0', 2))
}
// 带日期的时间字符串
function dtString(dt)  {
    return dateString(dt) + ' ' + timeString(dt)
}
// 带有日期和毫秒数的时间字符串
function fdtString(dt) {
    return dtString(dt) + '.' + padLeft(dt.getMilliseconds().toString(), '0', 3)
}

module.exports = {
    padLeft, padRight,
    dateString, dateNumber, timeString, timeNumber_seconds, timeNumber_minutes, timeNumber_hours,
    dtString, fdtString,
}