/**
 * 通用生成数据库 id 函数，{8位时间戳}-{6位随机码}
 */

import { padLeft } from './extender.js'
import { int2str, str2int } from './str2int.js'
import { customAlphabet } from 'nanoid/async'

const nanoid = customAlphabet('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', 6)

export default async function() {
    const dt = new Date()
    const ticks = dt.getTime()
    const rdm = await nanoid()
    return `${padLeft(int2str(ticks),'0',8)}-${rdm}`
}